! $Id: fix_pixel.prg,v 1.1 2000/07/13 21:45:05 cguirao Exp $
! $Name: FIASCO-1_3 $
!
! AUTHOR: C.Guirao
!
! NAME: fix_pixel.prg
!   Fix the pixel (bad or saturated one) from the image 'p1' in
!   pixel coordinates  given in 'p2'.
!
! INPUT:
!   - P1: input image in BDF format
!   - P2: Pixel coordinates of the pixel to be fixed.
!
! OUTPUT:
!   - P1: The fixed image in BDF format
!
!**********************************************************************
! ECHO/FULL 
!
! INPUT PARAMS:
! p1 REQUIRED: BDF input image 
! p2 REQUIRED: Pixel coordinates of the pixel to be fixed.
!
! Edit here to change defaults:
DEFINE/PARAM p1 ? image "Enter input image name:"
DEFINE/PARAM p2 ? no "Enter pixel coords:"
! 
DEFINE/LOCAL image/c/1/80 {p1}
DEFINE/LOCAL cpix/i/1/2 {p2}
DEFINE/LOCAL mm/i/1/3 0 all
DEFINE/LOCAL res/r/1/3 0 all
! 
mm(1) = cpix-1
mm(2) = cpix+1
res(1) = m$value({image}[@{mm(1)},@{cpix(2)}])
res(2) = m$value({image}[@{mm(2)},@{cpix(2)}])
res(3) = (res(1)+res(2))/2
! READ/KEY res
{image}[@{cpix(1)},@{cpix(2)}] = {res(3)}
! READ/IMAGE {image} @{mm(1)},@{cpix(2)},3
