! $Id: master_flat.prg,v 1.3 1999/08/14 19:53:02 cguirao Exp $
! $Name: FIASCO-1_3 $ 
!
! AUTHOR: C.Guirao
!
! NAME: master_flat.prg
!   Data reduction procedure to create a "master_flat.bdf" as
!   the result of averaging a set of flatfields (wildchars are
!   welcome) and normalized to 1
!
! INPUT: 
!   - P1: Set of flat field FITS or BDF frames 
!
! OUTPUT: 
!   - P2: master flat BDF image
!
!**********************************************************************       
! ECHO/FULL
!
! INPUT PARAMS:
! p1 REQUIRED: FITS images from flat fields
! p2 OPTIONAL: Name of the master flat field to be generated
!
! Edit here to change defaults:
!
 DEFINE/PARA p1 ?         IMA "Enter BDF or FITS frames of flat fields: "
 DEFINE/PARA p2 + ?       "Enter name for master flat field"
!
! Convert paramaters into variables:
!
 DEFINE/LOCA cmd/c/1/20		"master_flat"
 DEFINE/LOCA frame/c/1/40	{p1}
 DEFINE/LOCA average_flat/c/1/40 "average_flat.bdf"
 DEFINE/LOCA master_flat/c/1/40  "master_flat.bdf"
 DEFINE/LOCA modulated_flat/c/1/40 "modulated_flat.bdf"
 DEFINE/LOCA reply/c/1/1	y
!
! If BDF frame name {p2} is missing, use fitsframe without extension.
!
!
!  Master flat field
!
 IF p2 .ne. "+" THEN
   master_frame = {p2}
 ENDIF
!
! average the input files
!
 WRITE/OUT "{cmd}: averaging input flat fields"
 @@ averaging {p1} {average_flat}
!
! Initiate contex LONG and create a grap
!
 SHOW/CONTEXT long >NULL
 IF OUTPUTI(5) .eq. 0 THEN
   SET/CONTEXT long >NULL
 ENDIF
!
! Normalize the averaged flat image
!
 WRITE/OUT "{cmd}: normalizing master_flat"
 NORMAL/FLAT {average_flat} {master_flat}
!
! Remove the pixel to pixel variation 
!
! WRITE/OUT "{cmd}: retrieving the optical modulation"
! FILTER/MEDI {average_flat} {modulated_flat} 5,5,0 >NULL
!
! Iron the averaged flat by dividing by the filtered flat
!
! WRITE/OUT "{cmd}: ironing the averaged flat"
! COMPUTE/IMA {master_flat} = {average_flat} / {modulated_flat}
!
 askRemove:
 WRITE/KEYW reply/c/1/1 y
 INQUIRE/KEYW reply "Remove all temporary files [yn] (y)?"
 IF reply(:1) .eq. "y" THEN
   GOTO remove
 ELSEIF reply(:1) .eq. "n" THEN
   ECHO/OFF
   RETURN/EXIT
 ELSE
   GOTO askRemove
 ENDIF
 remove:
!
! Clean all temporary files.
!
 WRITE/OUT "{cmd}: cleaning temporary files and finishing"
 DELETE/IMA {average_flat} NO
 $rm -f NULL
! DELETE/IMA {modulated_flat} NO
!
 ECHO/OFF
