! $Id: synthesizing.prg,v 1.2 1999/09/23 16:58:29 cguirao Exp $
! $Name: FIASCO-1_3 $ 
!
! AUTHOR: C.Guirao
! NAME: synthesizing.prg: 
!  Creates a synthetic solar spectrum using the SPECTRUM and SMOOTH
!  programs from Richard O. Gray. Plots the result synthetic spectrum
!  using MIDAS
!  Commands 'spectrum' and 'smooth' are expected to be located in $PATH
! 
! USAGE: @@ synthesizing 
! EXAMPLES:
!*******************************************************************************
! ECHO/FULL
!
! INPUT PARAMS:
! p1 REQUIRED: FITS image to be converted
! p2 REQUIRED: Ouput BDF image
! p3 REQUIRED: Wavelength range to be calculated
! p4 REQUIRED: Ouput resolution
! p5 REQUIRED: Ouput step
!
! Edit here to change defaults:
!
 DEFINE/PARA p1 ? I "Enter input ASCII file (from SPECTRUM, e.g. sun.dat) ? "
 DEFINE/PARA p2 ? I "Enter ouput ASCII file ? "
 DEFINE/PARA p3 ? NUM "Enter wavelength range ? "
 DEFINE/PARA p4 ? NUM "Enter output resolution ? "
 DEFINE/PARA p5 ? NUM "Enter output step ? "
!
! Convert paramaters into variables:
!
 DEFINE/LOCA cmd/c/1/20  "synthesizing"
 DEFINE/LOCA input/c/1/40 	{p1}
 DEFINE/LOCA output/c/1/40	{p2}
 DEFINE/LOCA wave_range/r/1/2   {p3}
 DEFINE/LOCA resolution/r/1/1   {p4}
 DEFINE/LOCA step/r/1/1   	{p5}
!
! Expecting the script synthesizing.sh to be in $HOME/midwork.
! The commands 'spectrum' and 'smooth' are expected to be installed from
! package SPECTRUM
!
 $"$HOME"/midwork/synthesizing.sh {input} {output} {wave_range(1)} {wave_range(2)} {resolution} {step}
!
 $rm -rf sun.fmt
 $echo DEFINE/FIELD 1 8 R F15.3 :WAVE ANGSTROMS > sun.fmt 
 $echo DEFINE/FIELD 9 19 R F15.6 :FLUX INTENSITY >> sun.fmt
!
 CREATE/TABL sun 2 100 {output} sun.fmt
 COMPUT/TABL sun :FLUX = 1 - (:FLUX)
 RESET/DISP >NULL
 CREATE/GRAP
 SET/GRAP pm=1 font=0 stype=0 colour=1
 WRITE/OUT PLOT/TABL sun.tbl :WAVE :FLUX
 PLOT/TABL sun.tbl :WAVE :FLUX
!
! Cleaning temporary files
!
! WRITE/OUT {cmd}: Removing temporary files
 $rm -f NULL
!
 ECHO/OFF
